/* capability.c generated by valac 0.38.8, the Vala compiler
 * generated from capability.vala, do not modify */

/*
 * Copyright (c) 2016 gnome-pomodoro contributors
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Kamil Prusko <kamilprusko@gmail.com>
 *
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>


#define POMODORO_TYPE_CAPABILITY (pomodoro_capability_get_type ())
#define POMODORO_CAPABILITY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), POMODORO_TYPE_CAPABILITY, PomodoroCapability))
#define POMODORO_CAPABILITY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), POMODORO_TYPE_CAPABILITY, PomodoroCapabilityClass))
#define POMODORO_IS_CAPABILITY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), POMODORO_TYPE_CAPABILITY))
#define POMODORO_IS_CAPABILITY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), POMODORO_TYPE_CAPABILITY))
#define POMODORO_CAPABILITY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), POMODORO_TYPE_CAPABILITY, PomodoroCapabilityClass))

typedef struct _PomodoroCapability PomodoroCapability;
typedef struct _PomodoroCapabilityClass PomodoroCapabilityClass;
typedef struct _PomodoroCapabilityPrivate PomodoroCapabilityPrivate;

#define POMODORO_TYPE_CAPABILITY_GROUP (pomodoro_capability_group_get_type ())
#define POMODORO_CAPABILITY_GROUP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), POMODORO_TYPE_CAPABILITY_GROUP, PomodoroCapabilityGroup))
#define POMODORO_CAPABILITY_GROUP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), POMODORO_TYPE_CAPABILITY_GROUP, PomodoroCapabilityGroupClass))
#define POMODORO_IS_CAPABILITY_GROUP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), POMODORO_TYPE_CAPABILITY_GROUP))
#define POMODORO_IS_CAPABILITY_GROUP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), POMODORO_TYPE_CAPABILITY_GROUP))
#define POMODORO_CAPABILITY_GROUP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), POMODORO_TYPE_CAPABILITY_GROUP, PomodoroCapabilityGroupClass))

typedef struct _PomodoroCapabilityGroup PomodoroCapabilityGroup;
typedef struct _PomodoroCapabilityGroupClass PomodoroCapabilityGroupClass;
enum  {
	POMODORO_CAPABILITY_0_PROPERTY,
	POMODORO_CAPABILITY_NAME_PROPERTY,
	POMODORO_CAPABILITY_ENABLED_PROPERTY,
	POMODORO_CAPABILITY_GROUP_PROPERTY,
	POMODORO_CAPABILITY_NUM_PROPERTIES
};
static GParamSpec* pomodoro_capability_properties[POMODORO_CAPABILITY_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	POMODORO_CAPABILITY_ENABLE_SIGNAL,
	POMODORO_CAPABILITY_DISABLE_SIGNAL,
	POMODORO_CAPABILITY_NUM_SIGNALS
};
static guint pomodoro_capability_signals[POMODORO_CAPABILITY_NUM_SIGNALS] = {0};

typedef void (*PomodoroCapabilityFunc) (PomodoroCapability* capability, void* user_data);
struct _PomodoroCapability {
	GInitiallyUnowned parent_instance;
	PomodoroCapabilityPrivate * priv;
};

struct _PomodoroCapabilityClass {
	GInitiallyUnownedClass parent_class;
	void (*enable) (PomodoroCapability* self);
	void (*disable) (PomodoroCapability* self);
};

struct _PomodoroCapabilityPrivate {
	gchar* _name;
	gboolean _enabled;
	PomodoroCapabilityGroup* _group;
	PomodoroCapabilityFunc enable_func;
	gpointer enable_func_target;
	GDestroyNotify enable_func_target_destroy_notify;
	PomodoroCapabilityFunc disable_func;
	gpointer disable_func_target;
	GDestroyNotify disable_func_target_destroy_notify;
};


static gpointer pomodoro_capability_parent_class = NULL;

GType pomodoro_capability_get_type (void) G_GNUC_CONST;
GType pomodoro_capability_group_get_type (void) G_GNUC_CONST;
#define POMODORO_CAPABILITY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), POMODORO_TYPE_CAPABILITY, PomodoroCapabilityPrivate))
PomodoroCapability* pomodoro_capability_new (const gchar* name, PomodoroCapabilityFunc enable_func, void* enable_func_target, GDestroyNotify enable_func_target_destroy_notify, PomodoroCapabilityFunc disable_func, void* disable_func_target, GDestroyNotify disable_func_target_destroy_notify);
PomodoroCapability* pomodoro_capability_construct (GType object_type, const gchar* name, PomodoroCapabilityFunc enable_func, void* enable_func_target, GDestroyNotify enable_func_target_destroy_notify, PomodoroCapabilityFunc disable_func, void* disable_func_target, GDestroyNotify disable_func_target_destroy_notify);
void pomodoro_capability_set_name (PomodoroCapability* self, const gchar* value);
static void pomodoro_capability_real_dispose (GObject* base);
gboolean pomodoro_capability_get_enabled (PomodoroCapability* self);
const gchar* pomodoro_capability_get_name (PomodoroCapability* self);
static void pomodoro_capability_set_enabled (PomodoroCapability* self, gboolean value);
PomodoroCapabilityGroup* pomodoro_capability_get_group (PomodoroCapability* self);
void pomodoro_capability_set_group (PomodoroCapability* self, PomodoroCapabilityGroup* value);
static void pomodoro_capability_real_enable (PomodoroCapability* self);
const gchar* pomodoro_capability_group_get_name (PomodoroCapabilityGroup* self);
static void pomodoro_capability_real_disable (PomodoroCapability* self);
static void pomodoro_capability_finalize (GObject * obj);
static void _vala_pomodoro_capability_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_pomodoro_capability_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


PomodoroCapability* pomodoro_capability_construct (GType object_type, const gchar* name, PomodoroCapabilityFunc enable_func, void* enable_func_target, GDestroyNotify enable_func_target_destroy_notify, PomodoroCapabilityFunc disable_func, void* disable_func_target, GDestroyNotify disable_func_target_destroy_notify) {
	PomodoroCapability * self = NULL;
	const gchar* _tmp0_;
	PomodoroCapabilityFunc _tmp1_;
	void* _tmp1__target;
	GDestroyNotify _tmp1__target_destroy_notify;
	PomodoroCapabilityFunc _tmp2_;
	void* _tmp2__target;
	GDestroyNotify _tmp2__target_destroy_notify;
	g_return_val_if_fail (name != NULL, NULL);
	self = (PomodoroCapability*) g_object_new (object_type, NULL);
	_tmp0_ = name;
	pomodoro_capability_set_name (self, _tmp0_);
	_tmp1_ = enable_func;
	_tmp1__target = enable_func_target;
	_tmp1__target_destroy_notify = enable_func_target_destroy_notify;
	enable_func = NULL;
	enable_func_target = NULL;
	enable_func_target_destroy_notify = NULL;
	(self->priv->enable_func_target_destroy_notify == NULL) ? NULL : (self->priv->enable_func_target_destroy_notify (self->priv->enable_func_target), NULL);
	self->priv->enable_func = NULL;
	self->priv->enable_func_target = NULL;
	self->priv->enable_func_target_destroy_notify = NULL;
	self->priv->enable_func = _tmp1_;
	self->priv->enable_func_target = _tmp1__target;
	self->priv->enable_func_target_destroy_notify = _tmp1__target_destroy_notify;
	_tmp2_ = disable_func;
	_tmp2__target = disable_func_target;
	_tmp2__target_destroy_notify = disable_func_target_destroy_notify;
	disable_func = NULL;
	disable_func_target = NULL;
	disable_func_target_destroy_notify = NULL;
	(self->priv->disable_func_target_destroy_notify == NULL) ? NULL : (self->priv->disable_func_target_destroy_notify (self->priv->disable_func_target), NULL);
	self->priv->disable_func = NULL;
	self->priv->disable_func_target = NULL;
	self->priv->disable_func_target_destroy_notify = NULL;
	self->priv->disable_func = _tmp2_;
	self->priv->disable_func_target = _tmp2__target;
	self->priv->disable_func_target_destroy_notify = _tmp2__target_destroy_notify;
	(enable_func_target_destroy_notify == NULL) ? NULL : (enable_func_target_destroy_notify (enable_func_target), NULL);
	enable_func = NULL;
	enable_func_target = NULL;
	enable_func_target_destroy_notify = NULL;
	(disable_func_target_destroy_notify == NULL) ? NULL : (disable_func_target_destroy_notify (disable_func_target), NULL);
	disable_func = NULL;
	disable_func_target = NULL;
	disable_func_target_destroy_notify = NULL;
	return self;
}


PomodoroCapability* pomodoro_capability_new (const gchar* name, PomodoroCapabilityFunc enable_func, void* enable_func_target, GDestroyNotify enable_func_target_destroy_notify, PomodoroCapabilityFunc disable_func, void* disable_func_target, GDestroyNotify disable_func_target_destroy_notify) {
	return pomodoro_capability_construct (POMODORO_TYPE_CAPABILITY, name, enable_func, enable_func_target, enable_func_target_destroy_notify, disable_func, disable_func_target, disable_func_target_destroy_notify);
}


static void pomodoro_capability_real_dispose (GObject* base) {
	PomodoroCapability * self;
	gboolean _tmp0_;
	self = (PomodoroCapability*) base;
	_tmp0_ = self->priv->_enabled;
	if (_tmp0_) {
		g_signal_emit (self, pomodoro_capability_signals[POMODORO_CAPABILITY_DISABLE_SIGNAL], 0);
	}
	G_OBJECT_CLASS (pomodoro_capability_parent_class)->dispose ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_INITIALLY_UNOWNED, GInitiallyUnowned));
}


const gchar* pomodoro_capability_get_name (PomodoroCapability* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_name;
	result = _tmp0_;
	return result;
}


void pomodoro_capability_set_name (PomodoroCapability* self, const gchar* value) {
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, pomodoro_capability_get_name (self)) != 0) {
		const gchar* _tmp0_;
		gchar* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = g_strdup (_tmp0_);
		_g_free0 (self->priv->_name);
		self->priv->_name = _tmp1_;
		g_object_notify_by_pspec ((GObject *) self, pomodoro_capability_properties[POMODORO_CAPABILITY_NAME_PROPERTY]);
	}
}


gboolean pomodoro_capability_get_enabled (PomodoroCapability* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_enabled;
	result = _tmp0_;
	return result;
}


static void pomodoro_capability_set_enabled (PomodoroCapability* self, gboolean value) {
	g_return_if_fail (self != NULL);
	if (pomodoro_capability_get_enabled (self) != value) {
		gboolean _tmp0_;
		_tmp0_ = value;
		self->priv->_enabled = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, pomodoro_capability_properties[POMODORO_CAPABILITY_ENABLED_PROPERTY]);
	}
}


PomodoroCapabilityGroup* pomodoro_capability_get_group (PomodoroCapability* self) {
	PomodoroCapabilityGroup* result;
	PomodoroCapabilityGroup* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_group;
	result = _tmp0_;
	return result;
}


void pomodoro_capability_set_group (PomodoroCapability* self, PomodoroCapabilityGroup* value) {
	g_return_if_fail (self != NULL);
	if (pomodoro_capability_get_group (self) != value) {
		PomodoroCapabilityGroup* _tmp0_;
		_tmp0_ = value;
		self->priv->_group = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, pomodoro_capability_properties[POMODORO_CAPABILITY_GROUP_PROPERTY]);
	}
}


static void pomodoro_capability_real_enable (PomodoroCapability* self) {
	gboolean _tmp0_;
	_tmp0_ = self->priv->_enabled;
	if (!_tmp0_) {
		const gchar* _tmp1_ = NULL;
		PomodoroCapabilityGroup* _tmp2_;
		const gchar* _tmp6_;
		PomodoroCapabilityFunc _tmp7_;
		void* _tmp7__target;
		_tmp2_ = self->priv->_group;
		if (_tmp2_ != NULL) {
			PomodoroCapabilityGroup* _tmp3_;
			const gchar* _tmp4_;
			const gchar* _tmp5_;
			_tmp3_ = self->priv->_group;
			_tmp4_ = pomodoro_capability_group_get_name (_tmp3_);
			_tmp5_ = _tmp4_;
			_tmp1_ = _tmp5_;
		} else {
			_tmp1_ = "unknown";
		}
		_tmp6_ = self->priv->_name;
		g_debug ("capability.vala:52: Enable capability %s.%s", _tmp1_, _tmp6_);
		_tmp7_ = self->priv->enable_func;
		_tmp7__target = self->priv->enable_func_target;
		if (_tmp7_ != NULL) {
			PomodoroCapabilityFunc _tmp8_;
			void* _tmp8__target;
			_tmp8_ = self->priv->enable_func;
			_tmp8__target = self->priv->enable_func_target;
			_tmp8_ (self, _tmp8__target);
		}
		pomodoro_capability_set_enabled (self, TRUE);
	}
}


static void pomodoro_capability_real_disable (PomodoroCapability* self) {
	gboolean _tmp0_;
	_tmp0_ = self->priv->_enabled;
	if (_tmp0_) {
		const gchar* _tmp1_ = NULL;
		PomodoroCapabilityGroup* _tmp2_;
		const gchar* _tmp6_;
		PomodoroCapabilityFunc _tmp7_;
		void* _tmp7__target;
		_tmp2_ = self->priv->_group;
		if (_tmp2_ != NULL) {
			PomodoroCapabilityGroup* _tmp3_;
			const gchar* _tmp4_;
			const gchar* _tmp5_;
			_tmp3_ = self->priv->_group;
			_tmp4_ = pomodoro_capability_group_get_name (_tmp3_);
			_tmp5_ = _tmp4_;
			_tmp1_ = _tmp5_;
		} else {
			_tmp1_ = "unknown";
		}
		_tmp6_ = self->priv->_name;
		g_debug ("capability.vala:69: Disable capability %s.%s", _tmp1_, _tmp6_);
		_tmp7_ = self->priv->disable_func;
		_tmp7__target = self->priv->disable_func_target;
		if (_tmp7_ != NULL) {
			PomodoroCapabilityFunc _tmp8_;
			void* _tmp8__target;
			_tmp8_ = self->priv->disable_func;
			_tmp8__target = self->priv->disable_func_target;
			_tmp8_ (self, _tmp8__target);
		}
		pomodoro_capability_set_enabled (self, FALSE);
	}
}


static void pomodoro_capability_class_init (PomodoroCapabilityClass * klass) {
	pomodoro_capability_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PomodoroCapabilityPrivate));
	((GObjectClass *) klass)->dispose = (void (*) (GObject *)) pomodoro_capability_real_dispose;
	((PomodoroCapabilityClass *) klass)->enable = pomodoro_capability_real_enable;
	((PomodoroCapabilityClass *) klass)->disable = pomodoro_capability_real_disable;
	G_OBJECT_CLASS (klass)->get_property = _vala_pomodoro_capability_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_pomodoro_capability_set_property;
	G_OBJECT_CLASS (klass)->finalize = pomodoro_capability_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), POMODORO_CAPABILITY_NAME_PROPERTY, pomodoro_capability_properties[POMODORO_CAPABILITY_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), POMODORO_CAPABILITY_ENABLED_PROPERTY, pomodoro_capability_properties[POMODORO_CAPABILITY_ENABLED_PROPERTY] = g_param_spec_boolean ("enabled", "enabled", "enabled", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), POMODORO_CAPABILITY_GROUP_PROPERTY, pomodoro_capability_properties[POMODORO_CAPABILITY_GROUP_PROPERTY] = g_param_spec_object ("group", "group", "group", POMODORO_TYPE_CAPABILITY_GROUP, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	pomodoro_capability_signals[POMODORO_CAPABILITY_ENABLE_SIGNAL] = g_signal_new ("enable", POMODORO_TYPE_CAPABILITY, G_SIGNAL_RUN_FIRST, G_STRUCT_OFFSET (PomodoroCapabilityClass, enable), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	pomodoro_capability_signals[POMODORO_CAPABILITY_DISABLE_SIGNAL] = g_signal_new ("disable", POMODORO_TYPE_CAPABILITY, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PomodoroCapabilityClass, disable), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void pomodoro_capability_instance_init (PomodoroCapability * self) {
	self->priv = POMODORO_CAPABILITY_GET_PRIVATE (self);
}


static void pomodoro_capability_finalize (GObject * obj) {
	PomodoroCapability * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POMODORO_TYPE_CAPABILITY, PomodoroCapability);
	_g_free0 (self->priv->_name);
	(self->priv->enable_func_target_destroy_notify == NULL) ? NULL : (self->priv->enable_func_target_destroy_notify (self->priv->enable_func_target), NULL);
	self->priv->enable_func = NULL;
	self->priv->enable_func_target = NULL;
	self->priv->enable_func_target_destroy_notify = NULL;
	(self->priv->disable_func_target_destroy_notify == NULL) ? NULL : (self->priv->disable_func_target_destroy_notify (self->priv->disable_func_target), NULL);
	self->priv->disable_func = NULL;
	self->priv->disable_func_target = NULL;
	self->priv->disable_func_target_destroy_notify = NULL;
	G_OBJECT_CLASS (pomodoro_capability_parent_class)->finalize (obj);
}


GType pomodoro_capability_get_type (void) {
	static volatile gsize pomodoro_capability_type_id__volatile = 0;
	if (g_once_init_enter (&pomodoro_capability_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PomodoroCapabilityClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pomodoro_capability_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PomodoroCapability), 0, (GInstanceInitFunc) pomodoro_capability_instance_init, NULL };
		GType pomodoro_capability_type_id;
		pomodoro_capability_type_id = g_type_register_static (G_TYPE_INITIALLY_UNOWNED, "PomodoroCapability", &g_define_type_info, 0);
		g_once_init_leave (&pomodoro_capability_type_id__volatile, pomodoro_capability_type_id);
	}
	return pomodoro_capability_type_id__volatile;
}


static void _vala_pomodoro_capability_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	PomodoroCapability * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POMODORO_TYPE_CAPABILITY, PomodoroCapability);
	switch (property_id) {
		case POMODORO_CAPABILITY_NAME_PROPERTY:
		g_value_set_string (value, pomodoro_capability_get_name (self));
		break;
		case POMODORO_CAPABILITY_ENABLED_PROPERTY:
		g_value_set_boolean (value, pomodoro_capability_get_enabled (self));
		break;
		case POMODORO_CAPABILITY_GROUP_PROPERTY:
		g_value_set_object (value, pomodoro_capability_get_group (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_pomodoro_capability_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	PomodoroCapability * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POMODORO_TYPE_CAPABILITY, PomodoroCapability);
	switch (property_id) {
		case POMODORO_CAPABILITY_NAME_PROPERTY:
		pomodoro_capability_set_name (self, g_value_get_string (value));
		break;
		case POMODORO_CAPABILITY_ENABLED_PROPERTY:
		pomodoro_capability_set_enabled (self, g_value_get_boolean (value));
		break;
		case POMODORO_CAPABILITY_GROUP_PROPERTY:
		pomodoro_capability_set_group (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



